<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>

<body>

  <div class="container">
    <h2 style="text-align: center;">Danh sách người dùng</h2>

    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>
  <script>
    $(document).ready(function () {
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const COL_ARRAY_NAME = ["userId", "firstname", "lastname", "age", "action"];
      const COL_USER_ID = 0;
      const COL_FIRST_NAME = 1;
      const COL_LAST_NAME = 2;
      const COL_AGE = 3;
      const COL_ACTION = 4;
      var gJsonUser = `{
      "description": "Data user",
      "users": [
        {
          "userId": 1,
          "firstname": "Test1",
          "lastname": "User1",
          "age": 18
        },
        {
          "userId": 2,
          "firstname": "Test2",
          "lastname": "User2",
          "age": 19
        },
        {
          "userId": 3,
          "firstname": "Test3",
          "lastname": "User3",
          "age": 18
        },
        {
          "userId": 4,
          "firstname": "Test4",
          "lastname": "User4",
          "age": 20
        },
        {
          "userId": 5,
          "firstname": "Test5",
          "lastname": "User5",
          "age": 21
        },
        {
          "userId": 6,
          "firstname": "Test6",
          "lastname": "User6",
          "age": 20
        }
      ]
    }`;

      var gObjectData = JSON.parse(gJsonUser);
      console.log(gObjectData);
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();
      $(document).on("click", "#user-table .btn-detail", function () {
        console.log("click");
        onBtnDetailClick(this);
      })
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onBtnDetailClick(paramElement) {
        "use strict";
        var vTable = $("#user-table").DataTable();
        var vRowSelect = $(paramElement).closest("tr");
        var vDataRowSelect = vTable.row(vRowSelect).data();
        console.log(vDataRowSelect);
      }
      function onPageLoading() {
        /* Hãy đổ dữ liệu vào table và thực hiện nút information (chi tiết)
         * dùng cách khai báo data source ngay từ đầu */
        var vTable = $("#user-table").DataTable({
          columns: [
            { "data": COL_ARRAY_NAME[COL_USER_ID] },
            { "data": COL_ARRAY_NAME[COL_FIRST_NAME] },
            { "data": COL_ARRAY_NAME[COL_LAST_NAME] },
            { "data": COL_ARRAY_NAME[COL_AGE] },
            { "data": COL_ARRAY_NAME[COL_ACTION] }
          ],
          columnDefs: [
            {
              targets: COL_USER_ID,
              className: "text-right"
            },
            {
              targets: COL_AGE,
              className: "text-right"
            },
            {
              targets: COL_ACTION,
              className: "text-left",
              defaultContent: "<button class='btn btn-primary btn-detail'> Detail </button>"
            }
          ]
        })
        loadDataOnTable(gObjectData);
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function loadDataOnTable(paramObjectData) {
        "use strict";
        var vData = paramObjectData.users;
        var vTable = $("#user-table").DataTable();
        vTable.clear();
        vTable.rows.add(vData);
        vTable.draw();
      }
    });

  </script>
</body>

</html>